import * as types from '../types/index';
export declare let clickgo: typeof import('./clickgo');
export declare let control: typeof import('./lib/control');
export declare let core: typeof import('./lib/core');
export declare let dom: typeof import('./lib/dom');
export declare let form: typeof import('./lib/form');
export declare let fs: typeof import('./lib/fs');
export declare let native: typeof import('./lib/native');
export declare let storage: typeof import('./lib/storage');
export declare let task: typeof import('./lib/task');
export declare let theme: typeof import('./lib/theme');
export declare let tool: typeof import('./lib/tool');
export declare let zip: typeof import('./lib/zip');
export declare let vue: import('../types/index').IVueObject;
export declare function getVersion(): string;
export declare function isNative(): boolean;
export declare function getPlatform(): NodeJS.Platform | 'web';
export declare function isImmersion(): boolean;
export declare function hasFrame(): boolean;
export declare abstract class AbstractBoot {
    private readonly _debug;
    isDebug(): boolean;
    constructor(opt?: {
        'debug'?: boolean;
    });
    abstract main(): void | Promise<void>;
    onError(taskId: number, formId: number, error: Error, info: string): void | Promise<void>;
    onScreenResize(): void | Promise<void>;
    onConfigChanged<T extends types.IConfig, TK extends keyof T>(n: TK, v: T[TK]): void | Promise<void>;
    onFormCreated(taskId: number, formId: number, title: string, icon: string, showInSystemTask: boolean): void | Promise<void>;
    onFormRemoved(taskId: number, formId: number, title: string, icon: string): void | Promise<void>;
    onFormTitleChanged(taskId: number, formId: number, title: string): void | Promise<void>;
    onFormIconChanged(taskId: number, formId: number, icon: string): void | Promise<void>;
    onFormStateMinChanged(taskId: number, formId: number, state: boolean): void | Promise<void>;
    onFormStateMaxChanged(taskId: number, formId: number, state: boolean): void | Promise<void>;
    onFormShowChanged(taskId: number, formId: number, state: boolean): void | Promise<void>;
    onFormFocused(taskId: number, formId: number): void | Promise<void>;
    onFormBlurred(taskId: number, formId: number): void | Promise<void>;
    onFormFlash(taskId: number, formId: number): void | Promise<void>;
    onFormShowInSystemTaskChange(taskId: number, formId: number, value: boolean): void | Promise<void>;
    onFormHashChange(taskId: number, formId: number, value: string, data: Record<string, any>): void | Promise<void>;
    onTaskStarted(taskId: number): void | Promise<void>;
    onTaskEnded(taskId: number): void | Promise<void>;
    onLauncherFolderNameChanged(id: string, name: string): void | Promise<void>;
    onHashChanged(hash: string): void | Promise<void>;
    onKeydown(e: KeyboardEvent): void | Promise<void>;
    onKeyup(e: KeyboardEvent): void | Promise<void>;
    onRuntimeFileLoad(url: string): void | Promise<void>;
    onRuntimeFileLoaded(url: string, state: number): void | Promise<void>;
}
export declare function launcher(boot: AbstractBoot): void;
