import * as types from '../../types';
import * as form from './form';
export declare abstract class AbstractControl {
    get filename(): string;
    get controlName(): string;
    get taskId(): number;
    get formId(): number;
    private _rootForm;
    get rootForm(): form.AbstractForm & Record<string, any>;
    private readonly _rootControl;
    get rootControl(): (AbstractControl & Record<string, any>) | null;
    get formFocus(): boolean;
    get path(): string;
    get prep(): string;
    get locale(): string;
    get l(): (key: string, data?: string[]) => string;
    get classPrepend(): (cla: any) => string;
    get alignHComp(): string | undefined;
    get alignVComp(): string | undefined;
    watch<T extends this & this['props'], TK extends keyof T, TR>(name: TK | (() => TR), cb: (val: T[TK] & TR, old: T[TK] & TR) => void | Promise<void>, opt?: {
        'immediate'?: boolean;
        'deep'?: boolean;
    }): () => void;
    get refs(): Record<string, HTMLElement & AbstractControl & Record<string, any>>;
    get nextTick(): () => Promise<void>;
    allowEvent(e: MouseEvent | TouchEvent | KeyboardEvent): boolean;
    trigger(name: types.TGlobalEvent, param1?: boolean | Error | string, param2?: string): void;
    readonly packageFiles: Record<string, Blob | string>;
    readonly props: {};
    readonly emits: Record<string, null | ((payload: any) => boolean)>;
    readonly slots: Record<string, () => any[]>;
    get slotsAll(): (name: string) => any[];
    get propBoolean(): (name: keyof this["props"]) => boolean;
    get propNumber(): (name: keyof this["props"]) => number;
    get propInt(): (name: keyof this["props"]) => number;
    get propArray(): (name: keyof this["props"]) => any[];
    get element(): HTMLElement;
    emit(name: string, ...v: string | any): void;
    get parent(): AbstractControl & form.AbstractForm & Record<string, any>;
    get parentByName(): (controlName: string) => (AbstractControl & Record<string, any>) | null;
    get parentByAccess(): (name: string, val: string) => (AbstractControl & Record<string, any>) | null;
    onBeforeCreate(): void | Promise<void>;
    onCreated(): void | Promise<void>;
    onBeforeMount(): void | Promise<void>;
    onMounted(): void | Promise<void>;
    onBeforeUpdate(): void | Promise<void>;
    onUpdated(): void | Promise<void>;
    onBeforeUnmount(): void | Promise<void>;
    onUnmounted(): void | Promise<void>;
}
export declare function read(blob: Blob): Promise<false | types.TControlPackage>;
export declare function init(taskId: number, invoke: Record<string, any>, cache?: string): Promise<number>;
export declare function buildComponents(taskId: number, formId: number, path: string): false | Record<string, any>;
