import * as types from '../../types';
import * as form from './form';
export declare const config: types.IConfig;
export declare const global: any;
export declare abstract class AbstractApp {
    get filename(): string;
    get taskId(): number;
    set taskId(v: number);
    abstract main(data: Record<string, any>): Promise<void>;
    run(form: form.AbstractForm): void;
    onError(taskId: number, formId: number, error: Error, info: string): void | Promise<void>;
    onScreenResize(): void | Promise<void>;
    onConfigChanged<T extends types.IConfig, TK extends keyof T>(n: TK, v: T[TK]): void | Promise<void>;
    onFormCreated(taskId: number, formId: number, title: string, icon: string, showInSystemTask: boolean): void | Promise<void>;
    onFormRemoved(taskId: number, formId: number, title: string, icon: string): void | Promise<void>;
    onFormTitleChanged(taskId: number, formId: number, title: string): void | Promise<void>;
    onFormIconChanged(taskId: number, formId: number, icon: string): void | Promise<void>;
    onFormStateMinChanged(taskId: number, formId: number, state: boolean): void | Promise<void>;
    onFormStateMaxChanged(taskId: number, formId: number, state: boolean): void | Promise<void>;
    onFormShowChanged(taskId: number, formId: number, state: boolean): void | Promise<void>;
    onFormFocused(taskId: number, formId: number): void | Promise<void>;
    onFormBlurred(taskId: number, formId: number): void | Promise<void>;
    onFormFlash(taskId: number, formId: number): void | Promise<void>;
    onFormShowInSystemTaskChange(taskId: number, formId: number, value: boolean): void | Promise<void>;
    onFormHashChange(taskId: number, formId: number, value: string, data: Record<string, any>): void | Promise<void>;
    onTaskStarted(taskId: number): void | Promise<void>;
    onTaskEnded(taskId: number): void | Promise<void>;
    onLauncherFolderNameChanged(id: string, name: string): void | Promise<void>;
    onHashChanged(hash: string): void | Promise<void>;
    onKeydown(e: KeyboardEvent): void | Promise<void>;
    onKeyup(e: KeyboardEvent): void | Promise<void>;
}
export declare function getCdn(): string;
export declare let boot: import('../index').AbstractBoot;
export declare function regModule(name: string, func: () => any | Promise<any>): boolean;
export declare function getModule(name: string): Promise<null | any>;
export declare function trigger(name: types.TGlobalEvent, taskId?: number | string | boolean | KeyboardEvent, formId?: number | string | boolean | Record<string, any> | null, param1?: boolean | Error | string, param2?: string | Record<string, any>, param3?: boolean): void;
export declare function readApp(blob: Blob): Promise<false | types.IApp>;
export declare function fetchApp(url: string, opt?: types.ICoreFetchAppOptions, taskId?: number): Promise<null | types.IApp>;
export declare function getAvailArea(): types.IAvailArea;
export declare function hash(hash: string, taskId?: number): boolean;
export declare function getHash(): string;
export declare function getHost(): string;
export declare function location(url: string, taskId?: number): boolean;
export declare function getLocation(): string;
export declare function back(taskId?: number): boolean;
export declare function open(url: string): void;
