import * as types from '../../types';
export declare function inPage(el: HTMLElement): boolean;
export declare const dpi: number;
export declare function setGlobalCursor(type?: string): void;
export declare function hasTouchButMouse(e: MouseEvent | TouchEvent | PointerEvent): boolean;
export declare function createToStyleList(taskId: number): void;
export declare function removeFromStyleList(taskId: number): void;
export declare function pushStyle(taskId: number, style: string, type?: 'global' | 'theme' | 'control' | 'form', formId?: number | string, panelId?: number): void;
export declare function removeStyle(taskId: number, type?: 'global' | 'theme' | 'control' | 'form', formId?: number | string, panelId?: number): void;
export declare function getStyleCount(taskId: number, type: 'theme' | 'control' | 'form'): number;
export declare function watchPosition(el: HTMLElement, cb: (state: {
    'position': boolean;
    'size': boolean;
}) => void | Promise<void>, immediate?: boolean): boolean;
export declare function unwatchPosition(el: HTMLElement): void;
export declare function isWatchPosition(el: HTMLElement): boolean;
export declare function clearWatchPosition(formId: number | string, panelId?: number): void;
export declare function getWatchSizeCount(taskId?: number): number;
export declare function watchSize(el: HTMLElement, cb: () => void | Promise<void>, immediate?: boolean, taskId?: number): boolean;
export declare function unwatchSize(el: HTMLElement, taskId?: number): void;
export declare function isWatchSize(el: HTMLElement): boolean;
export declare function clearWatchSize(taskId: number): void;
export declare function getWatchCount(taskId?: number): number;
export declare function watch(el: HTMLElement, cb: (mutations: MutationRecord[]) => void | Promise<void>, mode?: 'child' | 'childsub' | 'style' | 'text' | 'default', immediate?: boolean, taskId?: number): boolean;
export declare function unwatch(el: HTMLElement, taskId?: number): void;
export declare function isWatch(el: HTMLElement): boolean;
export declare function clearWatch(taskId: number): void;
export declare function watchStyle(el: HTMLElement, name: string | string[], cb: (name: string, value: string, old: string) => void | Promise<void>, immediate?: boolean): void;
export declare function isWatchStyle(el: HTMLElement): boolean;
export declare function clearWatchStyle(formId: number | string, panelId?: number): void;
export declare function watchProperty(el: HTMLElement, name: string | string[], cb: (name: string, value: any) => void | Promise<void>, immediate?: boolean): void;
export declare function isWatchProperty(el: HTMLElement): boolean;
export declare function clearWatchProperty(formId: number | string, panelId?: number): void;
export declare function getWatchInfo(): types.IGetWatchInfoResult;
export declare function bindClick(e: MouseEvent | TouchEvent, handler: (e: MouseEvent | TouchEvent, x: number, y: number) => void | Promise<void>): void;
export declare function bindDblClick(e: MouseEvent | TouchEvent, handler: (e: MouseEvent | TouchEvent, x: number, y: number) => void | Promise<void>): void;
export declare function bindDown<T extends MouseEvent | TouchEvent>(oe: T, opt: types.IBindDownOptions<T>): void;
export declare function bindScale(oe: MouseEvent | TouchEvent | WheelEvent, handler: (e: MouseEvent | TouchEvent | WheelEvent, scale: number, cpos: {
    'x': number;
    'y': number;
}) => void | Promise<void>): void;
export declare function bindGesture(oe: MouseEvent | TouchEvent | WheelEvent, before: (e: MouseEvent | TouchEvent | WheelEvent, dir: 'top' | 'right' | 'bottom' | 'left') => number, handler?: (dir: 'top' | 'right' | 'bottom' | 'left') => void | Promise<void>): void;
export declare function allowEvent(e: MouseEvent | TouchEvent | KeyboardEvent): boolean;
export declare function bindLong(e: MouseEvent | TouchEvent, long: (e: MouseEvent | TouchEvent) => void | Promise<void>): void;
export declare function setDragData(data?: string | number | boolean | Record<string, any>): void;
export declare function bindDrag(e: MouseEvent | TouchEvent, opt: {
    'el': HTMLElement;
    'data'?: any;
    'start'?: (x: number, y: number) => any;
    'move'?: (e: MouseEvent | TouchEvent, opt: types.IBindMoveMoveOptions) => void;
    'end'?: (moveTimes: Array<{
        'time': number;
        'ox': number;
        'oy': number;
    }>, e: MouseEvent | TouchEvent) => void;
}): void;
export declare const is: {
    move: boolean;
    shift: boolean;
    ctrl: boolean;
    meta: boolean;
    full: boolean;
};
export declare function bindMove(e: MouseEvent | TouchEvent, opt: types.IBindMoveOptions): types.IBindMoveResult;
export declare function bindResize(e: MouseEvent | TouchEvent, opt: types.IBindResizeOptions): void;
export declare function findParentByData(el: HTMLElement, name: string, value?: string): HTMLElement | null;
export declare function findParentByClass(el: HTMLElement, name: string): HTMLElement | null;
export declare function findParentByTag(el: HTMLElement, name: string): HTMLElement | null;
export declare function index(el: HTMLElement): number;
export declare function siblings(el: HTMLElement): HTMLElement[];
export declare function siblingsData(el: HTMLElement, name: string): HTMLElement[];
export declare function fullscreen(): Promise<boolean>;
export declare function exitFullscreen(): Promise<boolean>;
export declare function createElement<T extends keyof HTMLElementTagNameMap>(tagName: T): HTMLElementTagNameMap[T];
