import * as types from '../../types';
export declare function mount(name: string, handler: types.IMountHandler, taskId?: number): boolean;
export declare function unmount(name: string): Promise<boolean>;
export declare function getContent(path: string, options?: {
    'start'?: number;
    'end'?: number;
    'progress'?: (loaded: number, total: number) => void | Promise<void>;
    'cache'?: string;
}, taskId?: number): Promise<string | Blob | null>;
export declare function getContent(path: string, options: BufferEncoding | {
    'encoding': BufferEncoding;
    'start'?: number;
    'end'?: number;
    'progress'?: (loaded: number, total: number) => void | Promise<void>;
    'cache'?: string;
}, taskId?: number): Promise<string | null>;
export declare function putContent(path: string, data: string | Blob, options?: {
    'encoding'?: BufferEncoding | null;
    'mode'?: string | number;
    'flag'?: string | number;
}, taskId?: number): Promise<boolean>;
export declare function readLink(path: string, encoding?: BufferEncoding, taskId?: number): Promise<string | null>;
export declare function symlink(filePath: string, linkPath: string, type?: 'dir' | 'file' | 'junction', taskId?: number): Promise<boolean>;
export declare function unlink(path: string, taskId?: number): Promise<boolean>;
export declare function stats(path: string, taskId?: number): Promise<types.IStats | null>;
export declare function isDir(path: string, taskId?: number): Promise<types.IStats | false>;
export declare function isFile(path: string, taskId?: number): Promise<types.IStats | false>;
export declare function mkdir(path: string, mode?: number, taskId?: number): Promise<boolean>;
export declare function rmdir(path: string, taskId?: number): Promise<boolean>;
export declare function rmdirDeep(path: string, taskId?: number): Promise<boolean>;
export declare function chmod(path: string, mod: string | number, taskId?: number): Promise<boolean>;
export declare function rename(oldPath: string, newPath: string, taskId?: number): Promise<boolean>;
export declare function readDir(path: string, encoding?: BufferEncoding, taskId?: number): Promise<types.IDirent[]>;
export declare function copyFolder(from: string, to: string, ignore?: RegExp[], taskId?: number): Promise<number>;
export declare function copyFile(src: string, dest: string, taskId?: number): Promise<boolean>;
