import * as types from '../../types';
export declare const list: Record<number, types.ITask>;
export declare let lastId: number;
export declare function setFocus(id?: number): void;
export declare function getFocus(): number | null;
export declare function onFrame(fun: () => void | Promise<void>, opt?: {
    'count'?: number;
    'taskId'?: number;
    'formId'?: number;
}): number;
export declare function offFrame(ft: number, opt?: {
    'taskId'?: number;
}): void;
export declare function get(tid: number): types.ITaskInfo | null;
export declare function getPermissions(tid: number): string[];
export declare function getList(): Record<string, types.ITaskInfo>;
export declare function run(url: string | types.IApp, opt?: types.ITaskRunOptions, ntid?: number): Promise<number>;
export declare function checkPermission(vals: string | string[], apply?: boolean, applyHandler?: (list: string[]) => void | Promise<void>, taskId?: number): Promise<boolean[]>;
export declare function end(taskId: number | string): boolean;
export declare function loadLocaleData(lang: string, data: Record<string, any>, pre?: string, taskId?: number): void;
export declare function loadLocale(lang: string, path: string, taskId?: number): Promise<boolean>;
export declare function clearLocale(taskId?: number): void;
export declare function setLocale(lang: string, path: string, taskId?: number): Promise<boolean>;
export declare function setLocaleLang(lang: string, taskId?: number): void;
export declare function clearLocaleLang(taskId?: number): void;
export declare function createTimer(fun: () => void | Promise<void>, delay: number, opt?: types.ICreateTimerOptions): number;
export declare function removeTimer(timer: number, taskId?: number): void;
export declare function sleep(fun: () => void | Promise<void>, delay: number, taskId?: number): number;
export declare const systemTaskInfo: types.ISystemTaskInfo;
export declare function setSystem(formId: number, taskId?: number): boolean;
export declare function clearSystem(taskId?: number | string): boolean;
export declare function refreshSystemPosition(): void;
