import * as types from '../../types';
export declare function compressor<T extends File | Blob>(file: T, options?: {
    'maxWidth'?: number;
    'maxHeight'?: number;
    'quality'?: number;
}): Promise<File | Blob | false>;
interface IClassPrototype {
    'method': Record<string, any>;
    'access': Record<string, {
        'get'?: any;
        'set'?: any;
    }>;
}
export declare function getClassPrototype(obj: object, over?: string[], level?: number): IClassPrototype;
export declare function blob2ArrayBuffer(blob: Blob): Promise<ArrayBuffer>;
export declare function sizeFormat(size: number, spliter?: string): string;
export declare function weightFormat(weight: number, spliter?: string): string;
export declare function clone(obj: Record<string, any> | any[]): any[] | any;
export declare function sleep(ms?: number): Promise<boolean>;
export declare function nextFrame(): Promise<void>;
export declare function sleepFrame(count: number): Promise<void>;
export declare function purify(text: string): string;
export declare function match(str: string, regs: RegExp[]): boolean;
export declare function styleUrl2DataUrl(path: string, style: string, files: Record<string, Blob | string>): Promise<string>;
export declare function layoutAddTagClassAndReTagName(layout: string, retagname: boolean): string;
export declare function layoutInsertAttr(layout: string, insert: string, opt?: {
    'ignore'?: RegExp[];
    'include'?: RegExp[];
}): string;
export declare function layoutClassPrepend(layout: string, preps: string[]): string;
export declare function eventsAttrWrap(layout: string): string;
export declare function teleportGlue(layout: string, formId: number | string): string;
export declare function stylePrepend(style: string, prep?: string): {
    'style': string;
    'prep': string;
};
export declare function getMimeByPath(path: string): {
    'mime': string;
    'ext': string;
};
export declare function rand(min: number, max: number): number;
export declare const RANDOM_N = "0123456789";
export declare const RANDOM_U = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
export declare const RANDOM_L = "abcdefghijklmnopqrstuvwxyz";
export declare const RANDOM_UN: string;
export declare const RANDOM_LN: string;
export declare const RANDOM_LU: string;
export declare const RANDOM_LUN: string;
export declare const RANDOM_V = "ACEFGHJKLMNPRSTWXY34567";
export declare const RANDOM_LUNS: string;
export declare function random(length?: number, source?: string, block?: string): string;
export declare function getBoolean(param: boolean | string | number | undefined): boolean;
export declare function getNumber(param: string | number): number;
export declare function getArray(param: string | any[]): any[];
export declare function escapeHTML(html: string): string;
export declare function formatColor(color: string): number[];
export declare function rgb2hex(r: string | number, g?: string | number, b?: string | number, a?: string | number): string;
export declare function hex2rgb(hex: string): {
    'r': number;
    'g': number;
    'b': number;
    'a': number;
    'rgb': string;
};
export declare function rgb2hsl(r: string | number, g?: string | number, b?: string | number, a?: string | number, decimal?: boolean): {
    'h': number;
    's': number;
    'l': number;
    'a': number;
    'hsl': string;
};
export declare function hsl2rgb(h: string | number, s?: string | number, l?: string | number, a?: string | number, decimal?: boolean): {
    'r': number;
    'g': number;
    'b': number;
    'a': number;
    'rgb': string;
};
export declare function request(url: string, opt: types.IRequestOptions): Promise<null | any>;
export declare function fetch(url: string, init?: RequestInit): Promise<string | Blob | null>;
export declare function get(url: string, opt?: {
    'credentials'?: 'include' | 'same-origin' | 'omit';
    'headers'?: HeadersInit;
}): Promise<Response | null>;
export declare function post(url: string, data: Record<string, any> | FormData, opt?: {
    'credentials'?: 'include' | 'same-origin' | 'omit';
    'headers'?: HeadersInit;
}): Promise<Response | null>;
export declare function getResponseJson(url: string, opt?: {
    'credentials'?: 'include' | 'same-origin' | 'omit';
    'headers'?: HeadersInit;
}): Promise<any | null>;
export declare function postResponseJson(url: string, data: Record<string, any> | FormData, opt?: {
    'credentials'?: 'include' | 'same-origin' | 'omit';
    'headers'?: HeadersInit;
}): Promise<any | null>;
export declare function parseUrl(url: string): ILoaderUrl;
export declare function urlResolve(from: string, to: string): string;
export declare function urlAtom(url: string): string;
export declare function blob2Text(blob: Blob): Promise<string>;
export declare function blob2DataUrl(blob: Blob): Promise<string>;
export declare function execCommand(ac: string): void;
export declare function compar(before: Array<string | number>, after: Array<string | number>): {
    'remove': Record<string, number>;
    'add': Record<string, number>;
    'length': {
        'remove': number;
        'add': number;
    };
};
export declare function formatSecond(second: number): string;
export declare function formatTime(ts: number | Date, tz?: number): {
    'date': string;
    'time': string;
    'zone': string;
};
export declare function isMs(time: number): boolean;
export declare function queryStringify(query: Record<string, any>): string;
export declare function queryParse(query: string): Record<string, string | string[]>;
export {};
