import jszip from 'jszip';
import * as types from '../../types';
export declare class Zip {
    private readonly _zip;
    private _path;
    constructor(zip: jszip);
    getContent(path: string): Promise<string | null>;
    getContent<T extends types.TZipOutputType>(path: string, type: T): Promise<types.IZipOutputByType[T] | null>;
    putContent<T extends types.TZipInputType>(path: string, data: types.IZipInputByType[T], options?: {
        'base64'?: boolean;
        'binary'?: boolean;
        'date'?: Date;
    }): void;
    unlink(path: string): void;
    stats(path: string): types.IZipStats | null;
    isDir(path: string): types.IZipStats | false;
    isFile(path: string): types.IZipStats | false;
    readDir(path?: string, opt?: {
        'hasChildren'?: boolean;
        'hasDir'?: boolean;
        'pathAsKey'?: false;
    }): types.IZipItem[];
    readDir(path?: string, opt?: {
        'hasChildren'?: boolean;
        'hasDir'?: boolean;
        'pathAsKey': true;
    }): Record<string, types.IZipItem>;
    private _readDir;
    private _list;
    private _refreshList;
    pwd(): string;
    cd(dir: string): string;
    generate<T extends types.TZipOutputType>(options?: {
        'type'?: T;
        'level'?: number;
        'onUpdate'?: (percent: number, currentFile: string | null) => void;
    }): Promise<types.IZipOutputByType[T]>;
    getList(): Promise<Record<string, Blob | string>>;
}
export declare function get(data?: types.TZipInputFileFormat): Promise<Zip | null>;
